#include <iostream>
#include <CGAL/Exact_predicates_inexact_constructions_kernel.h>
#include <CGAL/Delaunay_triangulation_2.h>
#include <CGAL/Triangulation_hierarchy_2.h>
#include <CGAL/point_generators_2.h>
#include <CGAL/iterator.h>
#include <CGAL/Timer.h>
typedef CGAL::Exact_predicates_inexact_constructions_kernel K;
typedef CGAL::Triangulation_vertex_base_2<K>                Vbb;
typedef CGAL::Triangulation_hierarchy_vertex_base_2<Vbb>    Vb;
typedef CGAL::Triangulation_face_base_2<K>                  Fb;
typedef CGAL::Triangulation_data_structure_2<Vb,Fb>         Tds;
typedef CGAL::Delaunay_triangulation_2<K,Tds>               Dt;
typedef CGAL::Triangulation_hierarchy_2<Dt>                 DT;
//typedef CGAL::Delaunay_triangulation_2<K>                   DT;
typedef CGAL::Random_points_in_square_2<DT::Point>          Rnd_points_it;

int main (int argc, char **argv)
{   int N = 1000000; if( argc > 1 )N = atoi(argv[1]); // number of points
    Rnd_points_it   rand_it( 1.0);
    DT dt;
    CGAL::Timer cost; cost.reset();cost.start();
    std::cout << " Dynamic Delaunay triangulation of "<<N<<" points in dim 2"<< std::flush;
    for(int i=0 ; i<N; ++i) dt.insert(*++rand_it);
    std::cout << " done in "<<cost.time()/N*1000000<<" micro-seconds per point." << std::endl;
    return 0;
}
