#include <iostream>
#include <CGAL/Exact_predicates_inexact_constructions_kernel.h>
#include <CGAL/Delaunay_triangulation_2.h>
#include <CGAL/Triangulation_hierarchy_2.h>
#include <CGAL/point_generators_2.h>
#include <CGAL/iterator.h>
#include <CGAL/Timer.h>
#include <CGAL/Real_timer.h>
typedef CGAL::Exact_predicates_inexact_constructions_kernel K;
typedef CGAL::Triangulation_vertex_base_2<K>                Vbb;
typedef CGAL::Triangulation_hierarchy_vertex_base_2<Vbb>    Vb;
typedef CGAL::Triangulation_face_base_2<K>                  Fb;
typedef CGAL::Triangulation_data_structure_2<Vb,Fb>         Tds;
typedef CGAL::Delaunay_triangulation_2<K,Tds>               Dt;
typedef CGAL::Triangulation_hierarchy_2<Dt>                 DT;
typedef CGAL::Random_points_in_square_2<DT::Point>          Rnd_points_it;

int main (int argc, char **argv)
{   double threshold = 500; if( argc > 1 ) threshold = atof(argv[1]); // threshold for swap
  int i,j,bunch=10000,ratio;
    Rnd_points_it   rand_it( 1.0);
    DT dt;
    CGAL::Timer cost,ct; cost.reset();cost.start(); ct.start();
    CGAL::Real_timer rt; rt.start();      rt.reset(); ct.reset();
    std::cout << " Dynamic Delaunay triangulation in dim 2, go to swap"<<std::endl
	      << "# inserted points     real time/cpu time"<<std::endl;
    for( i=1,j=1 ; true ; ++i,++j) {
      dt.insert(*++rand_it);
      if (j==bunch) {  j=0;
	ratio = (rt.time()/ct.time());
	std::cout << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b"
		  <<i<<"    ratio "<<ratio<<"  "<< std::flush;
	if (ratio>=5) std::cout<<std::endl;
	if (ratio>=threshold) std::cout<<std::endl;
	rt.reset(); ct.reset();}
    }
    std::cout << std::endl << i
	      << " points inserted in "<<cost.time()/i*1000000<<" micro-seconds per point." 
	      << std::endl
	      << "for last "<<bunch<<" points, real time "<<rt.time()<<" was "
	      <<threshold<<" more than cpu time "<<ct.time()<<std::endl;
    return 0;
}
