#include <iostream>
#include <CGAL/Exact_predicates_inexact_constructions_kernel.h>
#include <CGAL/Delaunay_triangulation_3.h>
#include <CGAL/point_generators_3.h>
#include <CGAL/iterator.h>
#include <CGAL/Timer.h>
typedef CGAL::Exact_predicates_inexact_constructions_kernel    K;
typedef CGAL::Delaunay_triangulation_3<K,CGAL::Fast_location>  DT;
typedef CGAL::Random_points_in_cube_3<DT::Point>               Rnd_points_it;

int main (int argc, char **argv)
{   int N = 1000000; if( argc > 1 )N = atoi(argv[1]); // number of points
    Rnd_points_it   rand_it( 1.0);
    DT dt;
    CGAL::Timer cost; cost.reset();cost.start();
    std::cout << " Dynamic Delaunay triangulation of "<<N<<" points in dim 3"<< std::flush;
    for(int i=0 ; i<N; ++i) dt.insert(*++rand_it);
    std::cout << " done in "<<cost.time()/N*1000000<<" micro-seconds per point." << std::endl;
    return 0;
}
